;;; Nicht Case-Sensitives Assoc gibt den ERSTEN Wert der auf Key pat zurck.
;;; Key kann entweder ein String oder auch eine Liste sein,
;;; wie bei assoc auch
;;; (MS-ASSOCX "Testtable" '(("Testtable" (((0 . 1.93092e+008)...
;;; oder auch
;;; (MS-ASSOCX '("Testtable" . 10) '((("Testtable" . 10)...
(defun MS-ASSOCX (KEY ALIST / X EOF)
  ;; Axels dotted? Funktion
  (defun dotted? (test-item /)
    (and
      (= (type test-item) 'LIST)
      (cdr test-item)
      (atom (cdr test-item))
    )
  )
  (defun UPCASE-IF (ARG)
    (if	(= (type ARG) 'STR)
      (strcase ARG)
      ARG
    )
  )
  (defun UPCASE-KEY (ARG /)
    (if	(DOTTED? ARG)
      (setq ARG (cons (UPCASE-IF (car ARG)) (UPCASE-IF (cdr ARG))))
      (setq ARG (UPCASE-IF ARG))
    )
  )
  (while (not EOF)
    (setq X (car ALIST))
    (if	(equal (UPCASE-KEY KEY) (UPCASE-KEY (car X)))
      (setq EOF (cons X EOF))
      (if (not (setq ALIST (cdr ALIST)))
	(setq EOF 't)
      )
    )
  )
  (if (= (type EOF) 'list)
    (car EOF)
  )
)


(defun C:DT:LAYTRANSLATE (/		 BNAME		FOUND?
			  FROM?		 LAYERS		LAYNAME
			  PREFIX	 PROPLIST
			  STRFULLPATHDWGNAME		STRFULLPATHNAME
			  TRANSLATENAMES
			 )
  (setq	bname	 "layertranslation"
	proplist '(Description	Freeze	     LayerOn	  Linetype
		   Lineweight	Lock	     Plottable	  TrueColor
		  )
  )
  (if (zerop (getvar "pstylemode"))
    (setq proplist (append proplist (list 'PlotStyleName)))
  )
  (if (not
	(setq strfullpathname (findfile "layertranslation.txt"))
      )
    (alert
      "\nDatei >layertranslation.txt< nicht gefunden! Funktionsende."
    )
    (if	(not
	  (setq strfullpathdwgname (findfile (strcat bname ".dwg")))
	)
      (alert
	"\nDatei >layertranslation.dwg< nicht gefunden! Funktionsende."
      )
      (progn
	(setq prefix "$$TRANSLATION$$"
	      layers (vla-get-layers
		       (vla-get-ActiveDocument (vlax-get-acad-object))
		     )
	)
	;; Umbenennen der vorhandenen Layer. Bei Namensgleichheit relevant!
	(vlax-for layer	layers
	  (if
	    (not
	      (member (strcase (vla-get-name layer)) '("0" "DEFPOINTS"))
	    )
	     (vla-put-name
	       layer
	       (strcat prefix (vla-get-name layer))
	     )
	  )
	)
	;; Import der Layereigenschaften und abhngiger Objekte, OHNE die Geometrien zu importieren
	(command "_.-insert" (strcat bname "="))
	(command)
	(setq translatenames
	       (mapcar
		 '(lambda (x)
		    (list (strcat prefix (car x)) (cadr x))
		  )
		 (load strfullpathname)
	       )
	)
	(vlax-for layer	layers
	  (if (setq
		found? (MS-ASSOCX (vla-get-name layer) translatenames)
	      )
	    (if	(setq
		  from?	(vlax-invoke-method layers 'Item (cadr found?))
		)
	      (progn
		(foreach prop (mapcar
				'(lambda (x)
				   (cons x (vlax-get-property from? x))
				 )
				proplist
			      )
		  (vlax-put-property layer (car prop) (cdr prop))
		)
		(vla-put-name layer (strcat prefix (cadr found?)))
	      )
	    )
	  )
	)
	(vlax-for layer	layers
	  (setq layname (vla-get-name layer))
	  (if (not (vl-string-search prefix layname))
	    (if	(not (member layname '("0" "DEFPOINTS")))
	      (progn
		(vla-delete layer)
		(vlax-release-object layer)
	      )
	    )
	  )
	)
	(vlax-for layer	layers
	  (setq layname (vla-get-name layer))
	  (if (vl-string-search prefix layname)
	    (vla-put-name
	      layer
	      (vl-string-subst "" prefix layname)
	    )
	  )
	)
      )
    )
  )
)

(C:DT:LAYTRANSLATE)
















































































				  
	